#ifndef common_h
#define common_h

#include <Arduino.h>

// generic
#define SERIAL_DEBUG true // enable serial output
#define WAKE_SLEEP_INTERVAL 5*60 // wake every 5 minutes

// board pins
#define SWBOOT 0
#define SW1 10
#define LED1 11

#define NTC1 A0
#define NTC2 A1
#define AN1 A2
#define AN2 A3
#define AN3 A4
#define AN4 A5

#define GPIO1 39
#define GPIO2 40
#define GPIO3 41
#define GPIO4 42

#define EN_PWR1_PIN 12
#define EN_PWR2_PIN 13
#define EN_5V_PSU_PIN 14

// adc
extern float R_NTC1, R_NTC2, V_AN1, V_AN2, V_AN3, V_AN4;
extern float V_pv, V_battery, V_3V3;
#define ADC_R_TOP 1e6
#define ADC_R_BOTTOM 100e3
#define ADC_VOLTAGE_CAL ((ADC_R_TOP+ADC_R_BOTTOM)/(ADC_R_BOTTOM)) // conversion factor of analogReadVolts output to measured volts

// temperature
extern float T_chip;
#define NTC_R_PULLUP 100e3

// WiFi
#define WIFI_CONNECT_TIMEOUT 15

// Config
struct s_ModuleConfig {
  String node_name="nanopower_dev";
  
  String wifi_ssid="YOUR_SSID";
  String wifi_password="YOUR_PASSWORD";
};
extern struct s_ModuleConfig ModuleConfig;
extern int wifi_mode;

extern RTC_DATA_ATTR int wakeups;

extern unsigned long timeStart;
extern unsigned long timeAdc;
extern unsigned long timeConnectWiFi;
extern unsigned long timeConnectMQTT;

void DebugPrintln(String string);
void DebugPrint(String string);

#endif